#ifndef _TRG_EVENT_H
#define _TRG_EVENT_H

#include "CmpLib.h"
#include "BasePacket.h"

#include "TObject.h"

// TrgEvent
//  a base class which stores TRG raw data

class TrgEvent : public TObject {
 public:
  enum ENums { N_SITR = 12, N_MODE = 16, N_DATA = 64 };

 protected:
  unsigned int fEvtPrev[N_DATA];  // Raw Trigger module data

  unsigned int fEventID;          // EventID + 0x80000000 (MSB)
  unsigned int fNtrgLck;          // Number of issued Trigger Acknowledge
  unsigned int fNclkPps;          // System clock count at GpsPPS recevied (50MHz)
  unsigned int fNclkRaw;          // System clock count (50MHz)
  unsigned int fNclkEna;          // System clock count during Trigger Enable (50MHz)
  unsigned int fNclkLiv;          // System clock count during Trigger Module is ready (50MHz)
  unsigned int fNgpsPPS;          // Number of received GpsPPS signal
  unsigned int fCoHitRw;          // Coincidence Hit Flag
  unsigned int fCoHitCD;          // Coincidence Count Down Hit Flag
  unsigned int fHitPatt;          // Detector Hit Pattern
  //  unsigned int fTsecond;
  //  unsigned int fTmicros;
  unsigned int fNtrgAck;          // Number of Trigger Acknowledge (total)
  unsigned int fNswtAck;          // Number of Trigger Acknowledge by the switch on board
  unsigned int fNextAck;          // Number of Trigger Acknowledge by the internal clock
  unsigned int fNlpcAck;          // Number of Trigger Acknowledge by the external signal on LPC
  unsigned int fNhpcAck;          // Number of Trigger Acknowledge by the external signal on HPC
  unsigned int fNcoMode[N_MODE];  // Number of coincidence generated by raw hit
  unsigned int fNcdMode[N_MODE];  // Number of coincidence generated by CD hit
  unsigned int fNclkACD;          // System clock count during ACD FEE is ready (50MHz)
  unsigned int fNclkCZT;          // System clock count during CZT FEE is ready (50MHz)
  unsigned int fNclkCs1;          // System clock count during CsI 1st FEE is ready (50MHz)
  unsigned int fNclkCs2;          // System clock count during CsI 2nd FEE is ready (50MHz)
  unsigned int fNclkSiT[N_SITR];  // System clock count during SiT[i] FEE is ready (50MHz)
  unsigned int fNhitACD;          // Number of ACD hit
  unsigned int fNoneSiT;          // Number of Si-Tracker hit. Any one layer hit (either X or Y )
  unsigned int fNandSiT;          // Number of Si-Tracker hit. Any one layer hit (both X and Y )
  unsigned int fNtwoSiT;          // Number of Si-Tracker hit. Any of two layer hit (either X or Y)
  unsigned int fNhitCZT;          // Number of CZT hit
  unsigned int fN1stCsI;          // Number of CsI hit from 1st FEE
  unsigned int fN2ndCsI;          // Number of CsI hit from 2nd FEE
  unsigned int fNhitXsi[N_SITR];  // Number of X-axis hit on i-th layer
  unsigned int fNhitYsi[N_SITR];  // Number of Y-axis hit on i-th layer

public:
  TrgEvent( void );
  virtual ~TrgEvent();

  // access functions
  unsigned int GetEventID( void ) const { return fEventID; }
  unsigned int GetNtrgLck( Bool_t raw = kFALSE ) const;
  unsigned int GetNclkPps( Bool_t raw = kFALSE ) const;
  unsigned int GetNclkRaw( Bool_t raw = kFALSE ) const;
  unsigned int GetNclkEna( Bool_t raw = kFALSE ) const;
  unsigned int GetNclkLiv( Bool_t raw = kFALSE ) const;
  unsigned int GetNgpsPPS( Bool_t raw = kFALSE ) const;
  unsigned int GetCoHitRw( void ) const { return fCoHitRw; }
  unsigned int GetCoHitCD( void ) const { return fCoHitCD; }
  unsigned int GetHitPatt( void ) const { return fHitPatt; }
  //  unsigned int GetTsecond( void ) const { return fTsecond; }
  //  unsigned int GetTmicros( void ) const { return fTmicros; }
  unsigned int GetNtrgAck( Bool_t raw = kFALSE ) const;
  unsigned int GetNswtAck( Bool_t raw = kFALSE ) const;
  unsigned int GetNextAck( Bool_t raw = kFALSE ) const;
  unsigned int GetNlpcAck( Bool_t raw = kFALSE ) const;
  unsigned int GetNhpcAck( Bool_t raw = kFALSE ) const;
  unsigned int GetNcoMode( int mode, Bool_t raw = kFALSE ) const;
  unsigned int GetNcdMode( int mode, Bool_t raw = kFALSE ) const;
  unsigned int GetNclkACD( Bool_t raw = kFALSE ) const;
  unsigned int GetNclkCZT( Bool_t raw = kFALSE ) const;
  unsigned int GetNclkCs1( Bool_t raw = kFALSE ) const;
  unsigned int GetNclkCs2( Bool_t raw = kFALSE ) const;
  unsigned int GetNclkSiT( int sitr, Bool_t raw = kFALSE ) const;
  unsigned int GetNhitACD( Bool_t raw = kFALSE ) const;
  unsigned int GetNoneSiT( Bool_t raw = kFALSE ) const;
  unsigned int GetNandSiT( Bool_t raw = kFALSE ) const;
  unsigned int GetNtwoSiT( Bool_t raw = kFALSE ) const;
  unsigned int GetNhitCZT( Bool_t raw = kFALSE ) const;
  unsigned int GetN1stCsI( Bool_t raw = kFALSE ) const;
  unsigned int GetN2ndCsI( Bool_t raw = kFALSE ) const;
  unsigned int GetNhitXsi( int sitr, Bool_t raw = kFALSE ) const;
  unsigned int GetNhitYsi( int sitr, Bool_t raw = kFALSE ) const;

  Int_t Fill   ( BasePacket *pkt );

  virtual void Clear( Option_t *option = "" );
  virtual void Print( Option_t *option = "" ) const;

  void SetEvent( unsigned int *data );
  void WriteCsv( std::ofstream& myFile, TString fTime );

  TrgEvent& operator= (const TrgEvent &trg);

 protected:
  unsigned int GetMSI( unsigned int data ) 
    const { return (0xFFFF & (data>>16) ); }
  unsigned int GetLSI( unsigned int data )
    const { return (0xFFFF & (data>> 0) ); }

  // class definition for ROOT
  ClassDef( TrgEvent, 1 )  // Trg branch class
};

#endif

// Local Variables:
// mode:C++
// End:
